import React, { useState, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { csv, arc, pie } from 'd3';

const csvUrl =
  'https://gist.githubusercontent.com/waseem-medhat/36f70b85ae76e6dc1bec647de6acb3c0/raw/cssColors.csv';
const width = 960;
const height = 500;


const pieArc = arc().innerRadius(width / 6).outerRadius(width);
const colorPie = pie().value(1);

const App = () => {
  const [data, setData] = useState(null);

  useEffect(() => csv(csvUrl).then(setData), []);

  if (!data) {
    return <pre>Loading...</pre>;
  }

  return (
    <svg width={width} height={height}>
      <g transform={`translate(${width / 2}, ${height / 2})`}>
        {colorPie(data).map((d) => (
          <path fill={d.data['RGB hex value']} d={pieArc(d)} />
        ))}
      </g>
    </svg>
  );

  return data.map((d) => (
    <div
      style={{
        backgroundColor: d['RGB hex value'],
        width: '100px',
        height: '100px',
      }}
    ></div>
  ));
};

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
